'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var slatePluginsCommon = require('@udecode/slate-plugins-common');
var slatePluginsCore = require('@udecode/slate-plugins-core');

const MARK_HIGHLIGHT = 'highlight';
const DEFAULTS_HIGHLIGHT = {
  hotkey: 'mod+shift+h'
};

const getHighlightDeserialize = () => editor => {
  const options = slatePluginsCore.getSlatePluginOptions(editor, MARK_HIGHLIGHT);
  return {
    leaf: slatePluginsCommon.getLeafDeserializer(Object.assign({
      type: options.type,
      rules: [{
        nodeNames: ['MARK']
      }]
    }, options.deserialize))
  };
};

/**
 * Enables support for highlights, useful when reviewing
 * content or highlighting it for future reference.
 */

const createHighlightPlugin = () => ({
  pluginKeys: MARK_HIGHLIGHT,
  renderLeaf: slatePluginsCore.getRenderLeaf(MARK_HIGHLIGHT),
  deserialize: getHighlightDeserialize(),
  onKeyDown: slatePluginsCommon.getToggleMarkOnKeyDown(MARK_HIGHLIGHT)
});

exports.DEFAULTS_HIGHLIGHT = DEFAULTS_HIGHLIGHT;
exports.MARK_HIGHLIGHT = MARK_HIGHLIGHT;
exports.createHighlightPlugin = createHighlightPlugin;
exports.getHighlightDeserialize = getHighlightDeserialize;
//# sourceMappingURL=index.js.map
